﻿using System;
using System.Collections.Generic;
using System.Text;

/* This simple application is written by Med Watt. I just started programming for fun
 * and through my love for mathematics, I was able to write such applications at faster
 * rate than I imagined. I hope you like my essay or whatever its called at 
 * http://en.literateprograms.org/Newton-Raphson. If you're reading this and you have
 * written yourself something than you're proud of, please let me know. You can email
 * me at medwatt@hotmail.com. I've also written other methods such as Laguerre, Durand
 * Kerner, Secant, Bairstow etc . . . with only one method baffling me. Thats the
 * Jenkins Traub method which I still cannot find any source that can explain it. If you
 * happen to know it, please let me know.... Bye*/




namespace Newton_Raphson
{
    class Program
    {
        static void Main(string[] args)
        {
            List<double> coeff= new List<double>();
            List<double> jcoeff= new List<double>();
            List<double> roots= new List<double>();
            
            double root = -0.5; double jroot = 1; int iterationNo = 0;



           Console.WriteLine("{0}\n{1}\n{2}", "Newton-Raphson Method", "", "");


            Console.WriteLine("Enter Real Coefficients");
            coeff.AddRange(Extract.ExtractCoeff(Console.ReadLine()));

            Console.WriteLine("Enter Imaginary Coefficients");
            jcoeff.AddRange(Extract.ExtractCoeff(Console.ReadLine()));


            while (coeff.Count>2)
            {
                while (++iterationNo <= 30)
                {
                    List<double> rawData = new List<double>();
                // Get f(x)
                rawData.AddRange(SubstDiff.SubDiff(coeff, jcoeff, root, jroot, 0));
                // Get f'(x)
                rawData.AddRange(SubstDiff.SubDiff(coeff, jcoeff, root, jroot, 1));

                // Divide f(x) by f'(x)
                rawData = Complex.Div(rawData[0], rawData[1], rawData[2], rawData[3]);


                // Subtract
                root -= rawData[0];
                jroot -= rawData[1];


                rawData.Clear();

            }

            roots.Add(root);
            roots.Add(jroot);
            Deflate.Horner(ref coeff, ref jcoeff, root, jroot);
            root = -0.5; jroot = 1; iterationNo = 0;

            }

            roots.Add(-coeff[1]);
            roots.Add(-jcoeff[1]);

            Console.WriteLine("");

            for (int element=0;element<=roots.Count-1; element+=2)
            {
                Console.WriteLine("{0}\t{1}",+roots[element],"j  " + roots[element + 1]);
            }



            Console.ReadKey();


        }
    }
}
